searchNodes=[{"doc":"lastfm_archive is a tool for creating local Last.fm scrobble file archive, Solr archive and analytics. The software is currently experimental and in preliminary development. It should eventually provide capability to perform ETL and analytic tasks on Lastfm scrobble data. Current usage: sync/0 , sync/1 : sync Lastfm scrobble data to local filesystem transform_archive/2 : transform downloaded raw data and create a TSV file archive load_archive/2 : load all (TSV) data from the archive into Solr","ref":"LastfmArchive.html","title":"LastfmArchive","type":"module"},{"doc":"Returns the total playcount and registered, i.e. earliest scrobble time for a user.","ref":"LastfmArchive.html#info/0","title":"LastfmArchive.info/0","type":"function"},{"doc":"Load all TSV data from the archive into Solr for a Lastfm user. The function finds TSV files from the archive and sends them to Solr for ingestion one at a time. It uses Hui client to interact with Solr and the Hui.URL.t/0 struct for Solr endpoint specification. Example # define a Solr endpoint with %Hui.URL{} struct headers = [ { &quot;Content-type&quot; , &quot;application/json&quot; } ] url = % Hui.URL { url : &quot;http://localhost:8983/solr/lastfm_archive&quot; , handler : &quot;update&quot; , headers : headers } LastfmArchive . load_archive ( &quot;a_lastfm_user&quot; , url ) TSV files must be pre-created before the loading - see transform_archive/2 .","ref":"LastfmArchive.html#load_archive/2","title":"LastfmArchive.load_archive/2","type":"function"},{"doc":"Sync scrobbles of a default user specified in configuration. Example LastfmArchive . sync The default user is specified in configuration, for example user_a in config/config.exs : config :lastfm_archive , user : &quot;user_a&quot; , ... # other archiving options See sync/2 for further details and archiving options.","ref":"LastfmArchive.html#sync/0","title":"LastfmArchive.sync/0","type":"function"},{"doc":"Sync scrobbles for a Lastfm user. Example LastfmArchive . sync ( &quot;a_lastfm_user&quot; ) The first sync downloads all daily scrobbles in 200-track (gzip compressed) chunks that are written into a local file archive. Subsequent syncs extract further scrobbles starting from the date of latest downloaded scrobbles. The data is currently in raw Lastfm recenttracks JSON format, chunked into 200-track (max) gzip compressed pages and stored within directories corresponding to the days when tracks were scrobbled. Options: :interval - default 1000 (ms), the duration between successive Lastfm API requests. This provides a control for request rate. The default interval ensures a safe rate that is within Lastfm's term of service: no more than 5 requests per second :overwrite - default false (not available currently), if sets to true the system will (re)fetch and overwrite any previously downloaded data. Use this option to refresh the file archive. Otherwise (false), the system will not be making calls to Lastfm to check and re-fetch data if existing data chunks / pages are found. This speeds up archive updating :per_page - default 200 , number of scrobbles per page in archive. The default is the max number of tracks per request permissible by Lastfm :data_dir - default lastfm_data . The file archive is created within a main data directory, e.g. ./lastfm_data/a_lastfm_user/ . These options can be configured in config/config.exs : config :lastfm_archive , ... data_dir : &quot;./lastfm_data/&quot;","ref":"LastfmArchive.html#sync/2","title":"LastfmArchive.sync/2","type":"function"},{"doc":"Transform downloaded raw JSON data and create a TSV file archive for a Lastfm user. Example LastfmArchive . transform_archive ( &quot;a_lastfm_user&quot; ) The function only transforms downloaded archive data on local filesystem. It does not fetch data from Lastfm, which can be done via archive/2 , archive/3 . The TSV files are created on a yearly basis and stored in gzip compressed format. They are stored in a tsv directory within either the default ./lastfm_data/ or the directory specified in config/config.exs ( :lastfm_archive, :data_dir ).","ref":"LastfmArchive.html#transform_archive/2","title":"LastfmArchive.transform_archive/2","type":"function"},{"doc":"","ref":"LastfmArchive.html#t:archive/0","title":"LastfmArchive.archive/0","type":"type"},{"doc":"","ref":"LastfmArchive.html#t:solr_url/0","title":"LastfmArchive.solr_url/0","type":"type"},{"doc":"","ref":"LastfmArchive.html#t:time_range/0","title":"LastfmArchive.time_range/0","type":"type"},{"doc":"Behaviour of a Lastfm archive. The module also provides a struct that keeps metadata about the archive. An archive contains scrobbles data retrieved from Lastfm API. It can be based upon various storage implementation such as file systems and databases.","ref":"LastfmArchive.Behaviour.Archive.html","title":"LastfmArchive.Behaviour.Archive","type":"behaviour"},{"doc":"Archives all scrobbles data for a Lastfm user.","ref":"LastfmArchive.Behaviour.Archive.html#c:archive/3","title":"LastfmArchive.Behaviour.Archive.archive/3","type":"callback"},{"doc":"Returns metadata of an existing archive.","ref":"LastfmArchive.Behaviour.Archive.html#c:describe/2","title":"LastfmArchive.Behaviour.Archive.describe/2","type":"callback"},{"doc":"Data struct containing new and some default metadata of an archive. Other metadata fields such as temporal, modified can be populated based on the outcomes of archiving, i.e. the implementation of the callbacks of this behaviour.","ref":"LastfmArchive.Behaviour.Archive.html#new/1","title":"LastfmArchive.Behaviour.Archive.new/1","type":"function"},{"doc":"","ref":"LastfmArchive.Behaviour.Archive.html#new/4","title":"LastfmArchive.Behaviour.Archive.new/4","type":"function"},{"doc":"Writes latest metadata to file.","ref":"LastfmArchive.Behaviour.Archive.html#c:update_metadata/2","title":"LastfmArchive.Behaviour.Archive.update_metadata/2","type":"callback"},{"doc":"","ref":"LastfmArchive.Behaviour.Archive.html#t:client/0","title":"LastfmArchive.Behaviour.Archive.client/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.Archive.html#t:options/0","title":"LastfmArchive.Behaviour.Archive.options/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.Archive.html#t:scrobbles/0","title":"LastfmArchive.Behaviour.Archive.scrobbles/0","type":"type"},{"doc":"Metadata descriping a Lastfm archive based on Dublin Core Metadata Initiative .","ref":"LastfmArchive.Behaviour.Archive.html#t:t/0","title":"LastfmArchive.Behaviour.Archive.t/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.Archive.html#t:user/0","title":"LastfmArchive.Behaviour.Archive.user/0","type":"type"},{"doc":"Behaviour and data struct for retrieving data from Lastfm API.","ref":"LastfmArchive.Behaviour.LastfmClient.html","title":"LastfmArchive.Behaviour.LastfmClient","type":"behaviour"},{"doc":"Returns the total playcount, registered, i.e. first scrobble time for a user.","ref":"LastfmArchive.Behaviour.LastfmClient.html#c:info/2","title":"LastfmArchive.Behaviour.LastfmClient.info/2","type":"callback"},{"doc":"Returns the playcount and the latest scrobble date of a user for a given time range.","ref":"LastfmArchive.Behaviour.LastfmClient.html#c:playcount/3","title":"LastfmArchive.Behaviour.LastfmClient.playcount/3","type":"callback"},{"doc":"Returns the scrobbles of a user for a given time range. See Lastfm API documentation for more details.","ref":"LastfmArchive.Behaviour.LastfmClient.html#c:scrobbles/3","title":"LastfmArchive.Behaviour.LastfmClient.scrobbles/3","type":"callback"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:client/0","title":"LastfmArchive.Behaviour.LastfmClient.client/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:from/0","title":"LastfmArchive.Behaviour.LastfmClient.from/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:latest_scrobble_time/0","title":"LastfmArchive.Behaviour.LastfmClient.latest_scrobble_time/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:limit/0","title":"LastfmArchive.Behaviour.LastfmClient.limit/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:page/0","title":"LastfmArchive.Behaviour.LastfmClient.page/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:playcount/0","title":"LastfmArchive.Behaviour.LastfmClient.playcount/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:registered_time/0","title":"LastfmArchive.Behaviour.LastfmClient.registered_time/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:to/0","title":"LastfmArchive.Behaviour.LastfmClient.to/0","type":"type"},{"doc":"","ref":"LastfmArchive.Behaviour.LastfmClient.html#t:user/0","title":"LastfmArchive.Behaviour.LastfmClient.user/0","type":"type"},{"doc":"GenServer storing archiving state to ensure scrobbles are fetched only once.","ref":"LastfmArchive.Cache.html","title":"LastfmArchive.Cache","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LastfmArchive.Cache.html#child_spec/1","title":"LastfmArchive.Cache.child_spec/1","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#clear/3","title":"LastfmArchive.Cache.clear/3","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#get/2","title":"LastfmArchive.Cache.get/2","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#c:get/2","title":"LastfmArchive.Cache.get/2","type":"callback"},{"doc":"","ref":"LastfmArchive.Cache.html#load/3","title":"LastfmArchive.Cache.load/3","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#c:load/3","title":"LastfmArchive.Cache.load/3","type":"callback"},{"doc":"","ref":"LastfmArchive.Cache.html#put/4","title":"LastfmArchive.Cache.put/4","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#c:put/4","title":"LastfmArchive.Cache.put/4","type":"callback"},{"doc":"","ref":"LastfmArchive.Cache.html#reset/2","title":"LastfmArchive.Cache.reset/2","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#serialise/3","title":"LastfmArchive.Cache.serialise/3","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#c:serialise/3","title":"LastfmArchive.Cache.serialise/3","type":"callback"},{"doc":"","ref":"LastfmArchive.Cache.html#start_link/1","title":"LastfmArchive.Cache.start_link/1","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#state/0","title":"LastfmArchive.Cache.state/0","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#state/1","title":"LastfmArchive.Cache.state/1","type":"function"},{"doc":"","ref":"LastfmArchive.Cache.html#t:end_of_day/0","title":"LastfmArchive.Cache.end_of_day/0","type":"type"},{"doc":"","ref":"LastfmArchive.Cache.html#t:start_of_day/0","title":"LastfmArchive.Cache.start_of_day/0","type":"type"},{"doc":"","ref":"LastfmArchive.Cache.html#t:user/0","title":"LastfmArchive.Cache.user/0","type":"type"},{"doc":"","ref":"LastfmArchive.Cache.html#t:year/0","title":"LastfmArchive.Cache.year/0","type":"type"},{"doc":"Client for extracting Lastfm user info and scrobbles data via the official API.","ref":"LastfmArchive.LastfmClient.html","title":"LastfmArchive.LastfmClient","type":"module"},{"doc":"","ref":"LastfmArchive.LastfmClient.html#default_user/0","title":"LastfmArchive.LastfmClient.default_user/0","type":"function"},{"doc":"Returns the total playcount and earliest scrobble date for a user.","ref":"LastfmArchive.LastfmClient.html#info/2","title":"LastfmArchive.LastfmClient.info/2","type":"function"},{"doc":"","ref":"LastfmArchive.LastfmClient.html#new/1","title":"LastfmArchive.LastfmClient.new/1","type":"function"},{"doc":"Returns the playcount of a user for a given time range.","ref":"LastfmArchive.LastfmClient.html#playcount/3","title":"LastfmArchive.LastfmClient.playcount/3","type":"function"},{"doc":"Returns the scrobbles of a user for a given time range. See Lastfm API documentation for more details.","ref":"LastfmArchive.LastfmClient.html#scrobbles/3","title":"LastfmArchive.LastfmClient.scrobbles/3","type":"function"},{"doc":"","ref":"LastfmArchive.LastfmClient.html#t:t/0","title":"LastfmArchive.LastfmClient.t/0","type":"type"},{"doc":"Livebook chart and text rendering.","ref":"LastfmArchive.Livebook.html","title":"LastfmArchive.Livebook","type":"module"},{"doc":"Display user name and total number of scrobbles to archive.","ref":"LastfmArchive.Livebook.html#info/1","title":"LastfmArchive.Livebook.info/1","type":"function"},{"doc":"Monthly playcounts of scrobbles archived so far - VegaLite heatmap.","ref":"LastfmArchive.Livebook.html#monthly_playcounts_heatmap/1","title":"LastfmArchive.Livebook.monthly_playcounts_heatmap/1","type":"function"},{"doc":"Returns a list of monthly playcounts of scrobbles archived so far.","ref":"LastfmArchive.Livebook.html#status/2","title":"LastfmArchive.Livebook.status/2","type":"function"},{"doc":"Yearly playcounts of scrobbles archived so far - Kino data table.","ref":"LastfmArchive.Livebook.html#yearly_playcounts_table/1","title":"LastfmArchive.Livebook.yearly_playcounts_table/1","type":"function"},{"doc":"","ref":"LastfmArchive.Livebook.html#t:monthy_count/0","title":"LastfmArchive.Livebook.monthy_count/0","type":"type"},{"doc":"This module provides functions for loading Lastfm data into databases and search engines.","ref":"LastfmArchive.Load.html","title":"LastfmArchive.Load","type":"module"},{"doc":"Check a Solr core/collection to ensure it has the required Lastfm data fields. The check currently inspects Solr schema for a list of Lastfm fields and returns error if one or more of the fields are missing. See LastfmArchive.Transform.transform/3 for the list of fields. Example LastfmArchive.Load . check_solr_schema ( &quot;http://solr_url...&quot; ) LastfmArchive.Load . check_solr_schema ( :lastfm_archive ) # ping a configured endpoint See ping_solr/1 for more details on URL configuration.","ref":"LastfmArchive.Load.html#check_solr_schema/1","title":"LastfmArchive.Load.check_solr_schema/1","type":"function"},{"doc":"Load a TSV file data from the archive into Solr for a Lastfm user. The function reads and converts scrobbles in a TSV file from the file archive into a list of maps. The maps are sent to Solr for ingestion. Use Hui.URL.t/0 struct to specify the Solr endpoint. Example # define a Solr endpoint with %Hui.URL{} struct headers = [ { &quot;Content-type&quot; , &quot;application/json&quot; } ] url = % Hui.URL { url : &quot;http://localhost:8983/solr/lastfm_archive&quot; , handler : &quot;update&quot; , headers : headers } # ingest data scrobbled in 2018 LastfmArchive.Load . load_solr ( url , &quot;a_lastfm_user&quot; , &quot;tsv/2018.tsv.gz&quot; ) TSV files must be pre-created by transforming raw JSON Lastfm data - see LastfmArchive.transform_archive/2 .","ref":"LastfmArchive.Load.html#load_solr/3","title":"LastfmArchive.Load.load_solr/3","type":"function"},{"doc":"Ping a Solr core/collection endpoint to check if it is running. The endpoint can either be a URL string or an atom referring to an endpoint in configuration. The library uses Hui to interact with Solr, an endpoint can be specified as below: Example LastfmArchive.Load . ping_solr ( &quot;http://solr_url...&quot; ) LastfmArchive.Load . ping_solr ( :lastfm_archive ) # check a configured endpoint :lastfm_archive refers to the following Solr update endpoint in configuration: config :hui , :lastfm_archive , url : &quot;http://solr_url..&quot; , handler : &quot;update&quot; , headers : [ { &quot;Content-type&quot; , &quot;application/json&quot; } ] See Hui.URL module for more details.","ref":"LastfmArchive.Load.html#ping_solr/1","title":"LastfmArchive.Load.ping_solr/1","type":"function"},{"doc":"This module provides functions for reading and transforming downloaded Lastfm data.","ref":"LastfmArchive.Transform.html","title":"LastfmArchive.Transform","type":"module"},{"doc":"Transform a downloaded raw JSON page into a list of tab-delimited track data. Example # transform a page of scrobbles from the file archive LastfmArchive.Transform . transform ( &quot;a_lastfm_user&quot; , &quot;2007/200_1.gz&quot; ) A row of tab-delimited track currently contains (if any): id auto-generated by the system to uniquely identify a scrobble name the track name scrobble_date Unix timestamp of the scrobble date scrobble_date_iso scrobble date in ISO 8601 datetime format mbid MusicBrainz identifier for the track url web address of the track on Last.fm artist artist_mbid MusicBrainz identifier for the artist artist_url web address of the artist on Last.fm album album_mbid MusicBrainz identifier for the album","ref":"LastfmArchive.Transform.html#transform/3","title":"LastfmArchive.Transform.transform/3","type":"function"},{"doc":"","ref":"LastfmArchive.Transform.html#tsv_headers/0","title":"LastfmArchive.Transform.tsv_headers/0","type":"function"},{"doc":"A tool for creating local Last.fm scrobble file archive and analytics. The software is currently experimental and in preliminary development. It should eventually provide capability to perform ETL and analytic tasks on Lastfm scrobble data.","ref":"readme.html","title":"Lastfm Archive","type":"extras"},{"doc":"Download and create a file archive of Lastfm scrobble tracks via an Elixir application or interactive Elixir by invoking iex -S mix command line action while in software home directory. # archive all data of a default user specified in configuration LastfmArchive . sync # subsequent calls download only latest scrobbles # archive all data of any Lastfm user # the data is stored in directory named after the user LastfmArchive . sync ( &quot;a_lastfm_user&quot; ) Scrobbles are extracted and stored in the file archive on a daily basis (granularity). The software has a built-in cache to remember and resume from the previous downloads. It skips already downloaded scrobbles and does not make further requests to Last.fm API. The data is currently in raw Lastfm recenttracks JSON format, chunked into 200-track (max) gzip compressed pages and stored within directories corresponding to the days when tracks were scrobbled. The file archive in a main directory specified in configuration - see below.","ref":"readme.html#current-usage","title":"Lastfm Archive - Current Usage","type":"extras"},{"doc":"LastfmArchive supports the use of Livebook interactive notebook for running archiving jobs, visualising archived data and analytics (forthcoming). Usage: install the interactive notebooks app start the app in a browser open the archiving notebook follow the configuration steps execute / evaluate code blocks to initiate archiving visualise archiving progress via playcount heatmap and table","ref":"readme.html#livebook-support","title":"Lastfm Archive - Livebook Support","type":"extras"},{"doc":"To generate a TSV file archive from downloaded data: # transform all existing data in a file archive into TSV files LastfmArchive . transform_archive ( &quot;a_lastfm_user&quot; ) See transform_archive/2 . To load all transformed TSV data from the archive into Solr: # define a Solr endpoint with %Hui.URL{} struct headers = [ { &quot;Content-type&quot; , &quot;application/json&quot; } ] url = % Hui.URL { url : &quot;http://localhost:8983/solr/lastfm_archive&quot; , handler : &quot;update&quot; , headers : headers } LastfmArchive . load_archive ( &quot;a_lastfm_user&quot; , url ) The function finds TSV files from the archive and send them to Solr for ingestion one at a time. It uses Hui client to interact with Solr and the Hui.URL.t/0 struct for Solr endpoint specification.","ref":"readme.html#other-usage","title":"Lastfm Archive - Other Usage","type":"extras"},{"doc":"This tool requires Elixir and Erlang, see installation details for various operating systems.","ref":"readme.html#requirement","title":"Lastfm Archive - Requirement","type":"extras"},{"doc":"lastfm_archive is available in Hex , the package can be installed by adding lastfm_archive to your list of dependencies in mix.exs : def deps do [ { :lastfm_archive , &quot;~&gt; 0.10&quot; } ] end Documentation can be found at https://hexdocs.pm/lastfm_archive .","ref":"readme.html#installation","title":"Lastfm Archive - Installation","type":"extras"},{"doc":"Add the following entries in your config - config/config.exs . For example, the following specifies a default_user and a main file location for multiple user archives, ./lastfm_data/ relative to the software home directory. You also need to specify an api-key in the config, so that the application can access Lastfm API . config :lastfm_archive , api : %{ api_key : &quot;api-key&quot; , endpoint : &quot;http://ws.audioscrobbler.com/&quot; , method : &quot;&quot; } , user : &quot;default_user&quot; , # the default user data_dir : &quot;./lastfm_data/&quot; , # main directory for multiple archives per_page : 200 , # 200 is max no. of tracks per call permitted by Lastfm API interval : 1000 # milliseconds between requests cf. Lastfm&#39;s max 5 reqs/s rate limit # optional: Solr endpoint for Lastfm data loading config :hui , :lastfm_archive , url : &quot;http://localhost:8983/solr/lastfm_archive&quot; , handler : &quot;update&quot; , headers : [ { &quot;Content-type&quot; , &quot;application/json&quot; } ] See sync/2 for other configurable archiving options, e.g. interval , per_page . See Hui for more details on Solr configuration. An api_key must be configured to enable Lastfm API requests, see https://www.last.fm/api (&quot;Get an API account&quot;).","ref":"readme.html#configuration","title":"Lastfm Archive - Configuration","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"first interactive notebook - Livebook support provide an archiving Livebook to initiate archiving jobs playcounts heatmap and table for visualising archiving progress","ref":"changelog.html#0-10-0-2023-06-07","title":"Changelog - 0.10.0 (2023-06-07)","type":"extras"},{"doc":"refactor: FileArchive - raw Lastfm scrobbles JSON format and better logging default runtime configuration to better support Livebook usage","ref":"changelog.html#0-9-3-2023-06-02","title":"Changelog - 0.9.3 (2023-06-02)","type":"extras"},{"doc":"info/0 returns total play count and first date of scrobble for default user update Lastfm client to use Livebook system env vars ( LB_LFM_USER and LB_LFM_API_KEY ) along with config values rename modules and tests in idiomatic namespaces bump dependencies, Elixir / Erlang versions Github Actions CI","ref":"changelog.html#0-9-2-2023-05-24","title":"Changelog - 0.9.2 (2023-05-24)","type":"extras"},{"doc":"sync/2 handles request errors from Last.fm API caches errors during sync so that subsequent syncs or API requests can be made to archive the missing scrobbles do not cache sync results of today's scrobbles as it's a always partial sync","ref":"changelog.html#0-9-1-2021-05-05","title":"Changelog - 0.9.1 (2021-05-05)","type":"extras"},{"doc":"Create an Archive behaviour with FileArchive implementation Extract and store scrobbles in daily chunks Extensive refactoring: simpler LastfmArchive functions core, deprecate archive functions Rewrite tests with mocks, eliminate file writes during tests Implement a GenServer simple tick-based (auto) cache memoization to prevent repetitive API calls to Last.fm","ref":"changelog.html#0-9-0-2021-04-14","title":"Changelog - 0.9.0 (2021-04-14)","type":"extras"},{"doc":"Update Elixir/Erlang versions and dependencies Replace HTTP client (HTTPoison) with Erlang's built-in httpc client Replace Poison with Jason for JSON decoding/encoding Apply mix formatting to the entire codebase Refactor and abstract LastfmArchive.Extract functions into a new module based on Lastfm.Client behaviour Implement explicit behaviour and contract-based unit testing (Hammox/Mox) Refactor and enable concurrent testing","ref":"changelog.html#0-8-0-2021-01-04","title":"Changelog - 0.8.0 (2021-01-04)","type":"extras"},{"doc":"Fix the issue of Last.fm changing the date/count data type in JSON back and forth (string &lt;-&gt; integer).","ref":"changelog.html#0-7-2-2019-02-25","title":"Changelog - 0.7.2 (2019-02-25)","type":"extras"},{"doc":"Patches as per Last.fm API JSON data format changes: uts timestamp, play counts info are now returned as integers instead of strings.","ref":"changelog.html#0-7-1-2019-01-14","title":"Changelog - 0.7.1 (2019-01-14)","type":"extras"},{"doc":"sync/0 , sync/1 : sync and keep tracks of scrobbles for a default and Last.fm users, via delta archiving (download latest scrobbles)","ref":"changelog.html#0-7-0-2019-01-11","title":"Changelog - 0.7.0 (2019-01-11)","type":"extras"},{"doc":"Support for Solr: load all transformed (TSV) data from the archive into Solr, load_archive/2 Underpinning functions to read, parse, load data into Solr","ref":"changelog.html#0-6-0-2018-11-10","title":"Changelog - 0.6.0 (2018-11-10)","type":"extras"},{"doc":"transform_archive/2 : transform downloaded raw Last.fm archive and create a TSV file archive Underpinning functions to read, parse and transform raw Lastfm JSON data into TSV files","ref":"changelog.html#0-5-0-2018-11-05","title":"Changelog - 0.5.0 (2018-11-05)","type":"extras"},{"doc":"fix single year archiving (bug): daily: true option","ref":"changelog.html#0-4-1-2018-11-01","title":"Changelog - 0.4.1 (2018-11-01)","type":"extras"},{"doc":"archive/3 : archiving data subset based on date ranges: single day/year, past week/month, arbitrary date range using Date , Date.Range structs daily: true option for finer-grained batch archiving cf. the default year-level granularity","ref":"changelog.html#0-4-0-2018-10-31","title":"Changelog - 0.4.0 (2018-10-31)","type":"extras"},{"doc":"overwrite archiving option to also re-fetch any existing downloaded data, for refreshing file archive","ref":"changelog.html#0-3-2-2018-10-27","title":"Changelog - 0.3.2 (2018-10-27)","type":"extras"},{"doc":"Keyword list archiving options ( per_page , interval ) for archive/2 which can also be configured","ref":"changelog.html#0-3-1-2018-10-27","title":"Changelog - 0.3.1 (2018-10-27)","type":"extras"},{"doc":"archive latest tracks (current year) on a daily basis to better ensure data immutability and updatability (new scrobbles) archive older tracks on a yearly basis","ref":"changelog.html#0-3-0-2018-10-26","title":"Changelog - 0.3.0 (2018-10-26)","type":"extras"},{"doc":"archive/0 : downloads scrobbled tracks, creates a file archive for a default user according to configuration settings archive/2 : downloads scrobbled tracks, creates a file archive for any Lastfm user write/3 : outputs data for multiple Lastfm users (no longer hardwired to the default user)","ref":"changelog.html#0-2-0-2018-10-23","title":"Changelog - 0.2.0 (2018-10-23)","type":"extras"},{"doc":"Download scrobbled tracks raw data, create an archive on local filesystem for a default user in configuration - archive/1 extract/5 and write/2 functions for Lastfm API requests and file output","ref":"changelog.html#0-1-0-2018-10-22","title":"Changelog - 0.1.0 (2018-10-22)","type":"extras"}]